#ifndef GRAPH_
#define GRAPH_

// 
#include <windows.h>
#include <math.h>
#include <ddraw.h>
#include <stdio.h>

//=======================

//  
#define BITMAP_NEW		1
#define BITMAP_EXISTING	2

// 
#define AXIS_NORMAL     1
#define AXIS_ARROW		2

//
#define ERROR_FLAG				1001 //  
#define ERROR_NOFLAG			1002 //     
#define ERROR_NODC				1003 //   dc
#define ERROR_NOCREATEBITMAP	1004 //   
#define ERROR_NOENDBITMAP		1005 //    
#define ERROR_FORMULA			1006 // 
#define ERROR_FONT				1007 //   
#define ERROR_SURF_CREATE		1008 //    
#define ERROR_TAB				1009 // -   
#define ERROR_LOAD_HTML_FILE	1010 // -   html 
#define ERROR_HTML_FORMAT		1011 // html  
#define ERROR_XLS				1012 //   xls 
#define ERROR_XLS_TAB			1013 //  xls 

//  
#define ERROR_S_1				2001 //  
#define ERROR_S_2				2002 //=   
#define ERROR_S_3				2003 //  

// 
#define DIAG_GRAPH				   1 // 
#define DIAG_GRAP_POINT			   2 //  
#define DIAG_GIST				 101 //

// 
#define G_SOLID				       1 //
#define G_DOT					   2 //
#define G_DASH					   3 //
#define G_DASHDOT				   4 //  
#define G_DASHDOTDOT			   5 //   

// 
#define D_SOLID					   1 //
#define D_BDIAGONAL				   2 
#define D_CROSS					   3
#define D_DIAGCROSS				   4
#define D_FDIAGONAL				   5
#define D_HORIZONTAL			   6
#define D_VERTICAL				   7

//   ReturnOptionRect
#define ROR_FON					   1 // 
#define ROR_FRAME				   2 // 
#define ROR_AXISX				   4 // X
#define ROR_AXISY				   8 // Y
#define ROR_ARROW				  16 //      - 
#define ROR_X					  32 // Y
#define ROR_0					  64 // 

//   ReturnDiagDisp
#define RDD_FON					   1 // 
#define RDD_FRAME				   2 // 
#define RDD_AXISX				   4 // X
#define RDD_AXISY				   8 // Y
#define RDD_ARROW				  16 //      - 
#define RDD_LEGEND				  32 //   
#define RDD_GRID				  64 //  
#define RDD_TEXT				 128 //  
#define RDD_TEXT_X				 256 //   X
#define RDD_TEXT_Y				 512 //   Y

// 
#define _PI_		       3.1415927

//   

struct OPTION_RECT
{
	RECT bitmap;// 
	BOOL Fon;//   
	COLORREF FonColor;// 
	COLORREF PenColor;//  
	BOOL Frame;//
	RECT FrameRect;// 
	COLORREF FrameColor;// 
	BOOL AxisX,AxisY;//
	COLORREF AxisColor;// 
	DWORD AxisType;// 
	BYTE AxisArrow;//  0 1 2 3 - 0   
	RECT DrawArea;// 
	double xMin,yMin,xMax,yMax;// 
	BOOL XY;//  x y true - x
	double Begin,End;//   
	double Period;// 
	COLORREF TextColor;
	int SizeFont;//  1-100
	char TextX[20];
	char TextY[20];
	BYTE  Nul;
};

struct TAB_GR
{
	INT tr;// 
	INT td;// 
	void *ptr;//  
};

struct DIAG_DISP
{
	RECT bitmap;// 
	BOOL Fon;//   
	COLORREF FonColor;// 
	BOOL Frame;//
	RECT FrameRect;// 
	COLORREF FrameColor;// 
	BOOL AxisX,AxisY;//
	COLORREF AxisColor;// 
	DWORD AxisType;// 
	WORD SizeAxisX,SizeAxisY;//    
	BYTE AxisArrow;//  0 1 2 3 - 0   
	RECT DrawArea;// 
	double Mimimum;//   - 0
	BOOL Legend;//   
	WORD LegendTop,LegendLeft,LegendBottom,LegendRight;// 
	BOOL LegendFrame;// 
	COLORREF LegendFrameColor;//  
	BOOL LegendFon;// 
	COLORREF LegendFonColor;//  
	WORD LegendFontSize;//  
	COLORREF LegendFontColor;//  
	BOOL Grid;//
	WORD GridType;//  0   
	BOOL GridX;//
	WORD GridY;//   X
	COLORREF GridColor;// 
	BOOL Text;//
	COLORREF TextColor;// 
	WORD TextSize;//  
	BOOL TextIn;//  
	COLORREF TextInColor;//   
	WORD TextInSize;//    
	char TextAxisX[20];
	char TextAxisY[20];
	BOOL TextAxis_X;//   X
	BOOL TextAxis_Y;
	void *text;//      X
	WORD Sizetext;//  
	WORD AllElem;//  
	void *elem;//   
	BYTE rd;//    
};

 
struct GRAPH_ELEM
{
	COLORREF ColorGr;// 
	BYTE Width;//
	int Style;//
	char Text[40];// 
};

struct EXCEL_TAB
{
	long sheet;//   
	char tab[20];//  - 
};

//

__declspec( dllimport ) INT CreateGraph(char * Formula,OPTION_RECT Rect,HBITMAP *HBitmap,DWORD Flags);
__declspec( dllimport ) INT CreateGraph(char * Formula,OPTION_RECT Rect,LPDIRECTDRAWSURFACE Surface,DWORD Flags);
__declspec( dllimport ) INT CreateGraph(char * Formula,OPTION_RECT Rect,char* FileName,DWORD Flags);

__declspec( dllimport ) INT CreateDiag(TAB_GR tab,DIAG_DISP Rect,HBITMAP *HBitmap,DWORD Flags,DWORD TypeDiag);
__declspec( dllimport ) INT CreateDiag(TAB_GR tab,DIAG_DISP Rect,LPDIRECTDRAWSURFACE Surface,DWORD Flags,DWORD TypeDiag);
__declspec( dllimport ) INT CreateDiag(TAB_GR tab,DIAG_DISP Rect,char* FileName,DWORD Flags,DWORD TypeDiag);

__declspec( dllimport ) INT CreateDiagHTML(char* FileHtml,DIAG_DISP Rect,HBITMAP *HBitmap,DWORD Flags,DWORD TypeDiag);
__declspec( dllimport ) INT CreateDiagHTML(char* FileHtml,DIAG_DISP Rect,LPDIRECTDRAWSURFACE Surface,DWORD Flags,DWORD TypeDiag);
__declspec( dllimport ) INT CreateDiagHTML(char* FileHtml,DIAG_DISP Rect,char* FileName,DWORD Flags,DWORD TypeDiag);

__declspec( dllimport ) INT CreateDiagXLS(char* FileXls,EXCEL_TAB,DIAG_DISP Rect,HBITMAP *HBitmap,DWORD Flags,DWORD TypeDiag);
__declspec( dllimport ) INT CreateDiagXLS(char* FileXls,EXCEL_TAB,DIAG_DISP Rect,LPDIRECTDRAWSURFACE Surface,DWORD Flags,DWORD TypeDiag);
__declspec( dllimport ) INT CreateDiagXLS(char* FileXls,EXCEL_TAB,DIAG_DISP Rect,char* FileName,DWORD Flags,DWORD TypeDiag);

__declspec( dllimport ) OPTION_RECT ReturnOptionRect(RECT bitmap,COLORREF FonColor,COLORREF PenColor,COLORREF FrameColor,
							 COLORREF AxisColor,double xMin,double yMin,double xMax,double yMax,
							 double Begin,double End,COLORREF TextColor,int SizeFont,char* TextX,
							 char* TextY,DWORD Flags);

__declspec( dllimport ) TAB_GR CreateTabGr(INT tr,INT td,double p,...);

__declspec( dllimport ) DIAG_DISP ReturnDiagDisp(RECT bitmap,COLORREF FonColor,COLORREF FrameColor,COLORREF AxisColor,WORD GridY,
						 COLORREF TextColor,WORD TextSize,COLORREF TextInColor,WORD TextInSize,
						 char* TextAxisX,char* TextAxisY,void *text,WORD Sizetext,WORD AllElem,
						 void *elem,BYTE rd,DWORD Flags);

__declspec( dllimport ) int CreateTextAxis(char*buf,WORD AllElem,char* txt,...);

__declspec( dllimport ) int CreateGraphElem(void *ptr,WORD AllElem,GRAPH_ELEM ge,...);

__declspec( dllimport ) GRAPH_ELEM ReturnGraphElem(COLORREF ColorGr,int Style,char* text);
//=======================

#endif
